GNU bug report logs - #38359
Guix 1.0.1-10.41b4b71 test fails on armhf

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Mathieu Othacehe <m.othacehe@HIDDEN>; Done: Mathieu Othacehe <m.othacehe@HIDDEN>; Maintainer for guix is bug-guix@HIDDEN.

Message received at 38359-done <at> debbugs.gnu.org:


Received: (at 38359-done) by debbugs.gnu.org; 10 Dec 2019 13:22:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 08:22:36 2019
Received: from localhost ([127.0.0.1]:55078 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iefTI-0000d8-Eq
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 08:22:36 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54661)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1iefTH-0000cv-3j
 for 38359-done <at> debbugs.gnu.org; Tue, 10 Dec 2019 08:22:35 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51989)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1iefTA-0006K6-VH; Tue, 10 Dec 2019 08:22:29 -0500
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=48186 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1iefTA-0008Kb-Es; Tue, 10 Dec 2019 08:22:28 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Mathieu Othacehe <m.othacehe@HIDDEN>
Subject: Re: bug#38359: Guix 1.0.1-10.41b4b71 test fails on armhf
References: <87a78ktbqm.fsf@HIDDEN> <87zhgisycj.fsf@HIDDEN>
 <877e3elumn.fsf@HIDDEN> <871rtdctrs.fsf@HIDDEN>
 <874ky8sdol.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 20 Frimaire an 228 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Tue, 10 Dec 2019 14:22:27 +0100
In-Reply-To: <874ky8sdol.fsf@HIDDEN> (Mathieu Othacehe's message of "Tue,
 10 Dec 2019 11:00:26 +0100")
Message-ID: <87muc0z564.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38359-done
Cc: 38359-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Bon dia!

Mathieu Othacehe <m.othacehe@HIDDEN> skribis:

>> As for the detection, this appears to work:
>>
>>   (define (binfmt-misc?)
>>     (let ((pid (getpid))
>>           (cmdline (call-with-input-file "/proc/self/cmdline" get-string=
-all)))
>>       (match (primitive-fork)
>>         (0 (dynamic-wind
>>              (const #t)
>>              (lambda ()
>>                (exit (not (equal? (call-with-input-file (format #f "/pro=
c/~a/cmdline" pid)
>>                                     get-string-all)
>>                                   cmdline))))
>>              (const #t)))
>>         (x (zero? (pk (cdr (waitpid x))))))))
>>
>> WDYT?
>
> Nice trick, I didn't think of forking process to fool qemu-user ;)
>
> Pushed a fix with your snippet as
> 0b5ad0e756a34d5e3ed1f37c3d4083a330fa33f5.

Awesome, thank you!

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.

Message received at 38359-done <at> debbugs.gnu.org:


Received: (at 38359-done) by debbugs.gnu.org; 10 Dec 2019 10:00:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 05:00:37 2019
Received: from localhost ([127.0.0.1]:54956 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iecJp-0001FI-1X
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 05:00:37 -0500
Received: from mail-wr1-f52.google.com ([209.85.221.52]:42627)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <m.othacehe@HIDDEN>) id 1iecJm-0001F5-UJ
 for 38359-done <at> debbugs.gnu.org; Tue, 10 Dec 2019 05:00:35 -0500
Received: by mail-wr1-f52.google.com with SMTP id a15so19248077wrf.9
 for <38359-done <at> debbugs.gnu.org>; Tue, 10 Dec 2019 02:00:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=references:user-agent:from:to:cc:subject:in-reply-to:date
 :message-id:mime-version;
 bh=kS5Xf4ySnyry9HSCeSMrO7eTROD+0BqZMLAjN3b4O9A=;
 b=iweeQEl2WE5fzN0C/TugOZG6gBwRE49zEsrzTPWN9/ZITpkBiEePZQq5Yo8ePVYWoG
 Vx4L4wfUDn1Rtg/xFacpRV6BEqKO7tEe0AnpJNUqyp5R+qS7kpLOpG3SyaWFTMiSX+F6
 a59+VcUEwKjlhYXq74ue8F7+KsmPZoDRcwktvJbV5pyRNFBFLCqym8ul/QlAw8647eyR
 7odOxp9GAGne5DAhLP80BNfSvTpj2bnFcaLHYLousbInAio4Q8QjIww5ydr+VYhCPFwl
 6X6oShNJWWYMRkVz3jrZi3EFEJa3wq4cY+ex347JdEarj9+5r4HmqNg/FJWee2vAgs2Y
 F9fA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:references:user-agent:from:to:cc:subject
 :in-reply-to:date:message-id:mime-version;
 bh=kS5Xf4ySnyry9HSCeSMrO7eTROD+0BqZMLAjN3b4O9A=;
 b=tx2FMaCb+sd/aL7bkXAkgxyroqxw3Nng/fC04RtR7TpoypFmBhceILDvO/WnRPGD4P
 nnZd/5UzmUSLzhWzYbv9i7D92P/BLPsqYeQNN+bOGYc1yGLXgpc4oNOn9k572fC/xcIn
 9cvc54mXAMjGf+vHYxBZ8pe1LWl6OdJrY351qOJRDwBbGmmHzZWML/lHlV4XpjqTKOoO
 Ep09CbxT0poCGVVXihlHy+5DfO60GC+79ixCLvIssDv8FF7maLtgbfxCfksz2GANpPh2
 zmlt6o9Us77PpKQf49l0knFTfDOekZUKAIo93oWU9M0U3KdfjMP883aCnACvvm/F3k8m
 g50A==
X-Gm-Message-State: APjAAAWZrFjbNLRve2/4dUYLCXUUSvgYaaaSHj0K0O1hr59h6XkPkcK2
 +Umr8SpBBgfuUz2ZX4jTlFeUq6eZ
X-Google-Smtp-Source: APXvYqyckP4/KG1LKFAbpYTmBAJ0650BN6NteBYIsT4TgKJsNylG8GakVzda66YzBSuYdIogRqK80A==
X-Received: by 2002:adf:bc4f:: with SMTP id a15mr2222464wrh.160.1575972028826; 
 Tue, 10 Dec 2019 02:00:28 -0800 (PST)
Received: from meru (lfbn-ann-1-237-90.w86-200.abo.wanadoo.fr. [86.200.196.90])
 by smtp.gmail.com with ESMTPSA id z4sm2568146wme.17.2019.12.10.02.00.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 10 Dec 2019 02:00:28 -0800 (PST)
References: <87a78ktbqm.fsf@HIDDEN> <87zhgisycj.fsf@HIDDEN>
 <877e3elumn.fsf@HIDDEN> <871rtdctrs.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Mathieu Othacehe <m.othacehe@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: bug#38359: Guix 1.0.1-10.41b4b71 test fails on armhf
In-reply-to: <871rtdctrs.fsf@HIDDEN>
Date: Tue, 10 Dec 2019 11:00:26 +0100
Message-ID: <874ky8sdol.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38359-done
Cc: 38359-done <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Hola!

> As for the detection, this appears to work:
>
>   (define (binfmt-misc?)
>     (let ((pid (getpid))
>           (cmdline (call-with-input-file "/proc/self/cmdline" get-string-all)))
>       (match (primitive-fork)
>         (0 (dynamic-wind
>              (const #t)
>              (lambda ()
>                (exit (not (equal? (call-with-input-file (format #f "/proc/~a/cmdline" pid)
>                                     get-string-all)
>                                   cmdline))))
>              (const #t)))
>         (x (zero? (pk (cdr (waitpid x))))))))
>
> WDYT?

Nice trick, I didn't think of forking process to fool qemu-user ;)

Pushed a fix with your snippet as
0b5ad0e756a34d5e3ed1f37c3d4083a330fa33f5.

Thanks,

Mathieu




Notification sent to Mathieu Othacehe <m.othacehe@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Mathieu Othacehe <m.othacehe@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 38359 <at> debbugs.gnu.org:


Received: (at 38359) by debbugs.gnu.org; 9 Dec 2019 17:07:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 12:07:29 2019
Received: from localhost ([127.0.0.1]:54360 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieMVN-0000k9-9m
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 12:07:29 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1ieMVM-0000jy-9B
 for 38359 <at> debbugs.gnu.org; Mon, 09 Dec 2019 12:07:28 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35917)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1ieMVH-0001BR-6P; Mon, 09 Dec 2019 12:07:23 -0500
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=53952 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1ieMVG-0001QI-N2; Mon, 09 Dec 2019 12:07:23 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Mathieu Othacehe <m.othacehe@HIDDEN>
Subject: Re: bug#38359: Guix 1.0.1-10.41b4b71 test fails on armhf
References: <87a78ktbqm.fsf@HIDDEN> <87zhgisycj.fsf@HIDDEN>
 <877e3elumn.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 19 Frimaire an 228 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Mon, 09 Dec 2019 18:07:19 +0100
In-Reply-To: <877e3elumn.fsf@HIDDEN> (Mathieu Othacehe's message of "Mon,
 02 Dec 2019 14:33:36 +0100")
Message-ID: <871rtdctrs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38359
Cc: 38359 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Mathieu,

Sorry for the delay!

Mathieu Othacehe <m.othacehe@HIDDEN> skribis:

>> Mmmh, I get what's going on in tests/processes.scm. It's an issue in
>> (guix scripts processes) where argv0 is checked for "guix-daemon".
>>
>> When using --system my-system, argv0 is "qemu-my-system". So we need to
>> check both argv0 and argv1 for "guix-daemon".
>>
>> I'll propose a patch.

Good catch!  When =E2=80=9Ctransparent=E2=80=9D emulation is no longer tran=
sparent=E2=80=A6

> Here it is. Please tell me what you think. Another solution would be to
> accept that (guix process) is broken when guix-daemon is run via binfmt
> and disable the tests in that case. However, I don't know how to detect
> it properly for the test suite.

It=E2=80=99s kinda ugly, but I=E2=80=99d be tempted to go for that second s=
olution:
detecting in tests/processes.scm that we=E2=80=99re under binfmt_misc and
skipping tests.

The reason is that while your patch looks great to me, it would break
when new =E2=80=9Cguix processes=E2=80=9D is used with an old daemon.  Ther=
e are other
details, like =E2=80=9Cguix/PID=E2=80=9D is not as nice as =E2=80=9Cguix-da=
emon PID=E2=80=9D (or
similar) for grepping purposes, but =E2=80=9Cguix-daemon PID=E2=80=9D might=
 hit the
limit on command name length.  Tricky!

As for the detection, this appears to work:

  (define (binfmt-misc?)
    (let ((pid (getpid))
          (cmdline (call-with-input-file "/proc/self/cmdline" get-string-al=
l)))
      (match (primitive-fork)
        (0 (dynamic-wind
             (const #t)
             (lambda ()
               (exit (not (equal? (call-with-input-file (format #f "/proc/~=
a/cmdline" pid)
                                    get-string-all)
                                  cmdline))))
             (const #t)))
        (x (zero? (pk (cdr (waitpid x))))))))

WDYT?

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Dec 2019 13:33:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 08:33:55 2019
Received: from localhost ([127.0.0.1]:37243 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iblpq-0004H1-Ho
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 08:33:55 -0500
Received: from lists.gnu.org ([209.51.188.17]:34460)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <m.othacehe@HIDDEN>) id 1iblpo-0004Gs-OG
 for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 08:33:53 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:58898)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <m.othacehe@HIDDEN>) id 1iblpm-0001yp-0K
 for bug-guix@HIDDEN; Mon, 02 Dec 2019 08:33:52 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <m.othacehe@HIDDEN>) id 1iblpi-0005Pr-D3
 for bug-guix@HIDDEN; Mon, 02 Dec 2019 08:33:49 -0500
Received: from mail-wr1-x436.google.com ([2a00:1450:4864:20::436]:45865)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <m.othacehe@HIDDEN>)
 id 1iblpf-0005Ls-Dn
 for bug-guix@HIDDEN; Mon, 02 Dec 2019 08:33:43 -0500
Received: by mail-wr1-x436.google.com with SMTP id j42so18433248wrj.12
 for <bug-guix@HIDDEN>; Mon, 02 Dec 2019 05:33:41 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=references:user-agent:from:to:subject:in-reply-to:date:message-id
 :mime-version; bh=FZIozCxqgVPKZGj96TZf6NbDWhBAiZMVQUQs8aEZEsg=;
 b=Jve6iSlyl4torBeqM9/tVQg1M11rO1je4GO3CvHfBPoClTok9Qinj9gscwx0EEXg3k
 Wbq9dwPjnl0w1TOCjfU1rcxJEnl+0006iubO0bsaHbdN+nwzTvkvVvqkF59SichcsROy
 /6HULByi5wqnXy+AVw5T5dcPKq3yNmnRTbPq3G/GQRMCasv7ov4YgqYudwsbztsoA2/Z
 CQQhrIoMqQERnRlh9GnehJ/t3HEA1xlgmMsQVkKLaddYqfp1qV27voBH+n3TCG5Tuh7v
 11dmaM0WEJ063JUCtrjI1BajaEgHXFH1tUL2tXZ2U3tSfELyezMNdTRASybuIgepaLgA
 400g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:references:user-agent:from:to:subject
 :in-reply-to:date:message-id:mime-version;
 bh=FZIozCxqgVPKZGj96TZf6NbDWhBAiZMVQUQs8aEZEsg=;
 b=pDuy8dvcnKtpTZfCsyqnNjP9bkI1awXNGoo7wfJcYGhgiwVSSJ7qYz1BmEAQS/pmrt
 LEpso4DOHCzl6Wp0h7mM8qU1eD5lVOORuK+e/JilKF54jvjUdMcez7W++foOj2O07UO6
 ZMwirQGN0+Jfa5APSnN30gqToHu7DCbEksLtqGMp0Z/RJ7kZ3H/Xvd9tni0i0RurTOwm
 ZWh+LOLgfkwai7f5kAWcqGofCsXXyF9mQ7JKuaDZansVUWmOFF/LHbT78iHdqsU7YbC+
 hudvi3F1aRfD7VXyerptYnYSTr8c53ZlccJbjQ9SCESsdS/xgUKOetnDrOtb39Ss34SX
 pwXw==
X-Gm-Message-State: APjAAAVmPGXJjjAqk+qa9DGKPEgXvul7B0JaeKfIqrfGgYk6jy4EXymB
 NFx99x/a5Ib1K+Sboo9POuktjOpt
X-Google-Smtp-Source: APXvYqzfTos5/8s1onrpnX0PmRyipAYSGjq5svD25DEcf11ZV/VjV6CRiB/nR3nkcpImePStqTyhFg==
X-Received: by 2002:adf:dc86:: with SMTP id r6mr55122024wrj.68.1575293620082; 
 Mon, 02 Dec 2019 05:33:40 -0800 (PST)
Received: from meru (lfbn-ann-1-237-90.w86-200.abo.wanadoo.fr. [86.200.196.90])
 by smtp.gmail.com with ESMTPSA id y8sm40457983wru.59.2019.12.02.05.33.36
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 02 Dec 2019 05:33:38 -0800 (PST)
References: <87a78ktbqm.fsf@HIDDEN> <87zhgisycj.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Mathieu Othacehe <m.othacehe@HIDDEN>
To: bug-guix@HIDDEN
Subject: Re: Guix 1.0.1-10.41b4b71 test fails on armhf
In-reply-to: <87zhgisycj.fsf@HIDDEN>
Date: Mon, 02 Dec 2019 14:33:36 +0100
Message-ID: <877e3elumn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::436
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

--=-=-=
Content-Type: text/plain


> Mmmh, I get what's going on in tests/processes.scm. It's an issue in
> (guix scripts processes) where argv0 is checked for "guix-daemon".
>
> When using --system my-system, argv0 is "qemu-my-system". So we need to
> check both argv0 and argv1 for "guix-daemon".
>
> I'll propose a patch.

Here it is. Please tell me what you think. Another solution would be to
accept that (guix process) is broken when guix-daemon is run via binfmt
and disable the tests in that case. However, I don't know how to detect
it properly for the test suite.

WDYT?

Mathieu

--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=0001-process-Fix-binfmt-support.patch

From 3b6f5708043a29343275fadf0b0e0e651bb6971e Mon Sep 17 00:00:00 2001
From: Mathieu Othacehe <m.othacehe@HIDDEN>
Date: Fri, 29 Nov 2019 10:37:12 +0100
Subject: [PATCH] process: Fix binfmt support.

Guix-daemon does fork itself for each client process. The pid of the client is
hardcoded into the clone argv[1] field. (guix process) uses this debugging
feature to detect guix-daemon clients.

This does not work when the guix-daemon is run by binfmt. In that case two
problem occurs:

* Command line parsing fails because guix-daemon command line looks like
/gnu/store/xxx-qemu-arm /gnu/store/yyy-guix-daemon ... instead of just
/gnu/store/yyy-guix-daemon ...

* The pid stuffing mechanism does not work because the memory location of argv
differs when the forked process is in reality run by qemu-arm through binfmt.

The first problem is solved by reading /proc/pid/comm instead of parsing
/proc/pid/cmdline to detect if a process is a guix-daemon.

The second problem is solved by renaming guix-daemon forked process to
"guix/<client-pid>" using PR_SET_NAME. Then, (guix process) can parse the
process name instead of the cmdline to find client pids.

* nix/nix-daemon/nix-daemon.cc (acceptConnection): Change the forked process
name to "guix/<client-pid>" with PR_SET_NAME.
* guix/scripts/processes.scm (<process>): "command" field now contains the
content of /proc/pid/comm. Add a new field "command-line" to store the process
command line.
(read-command): New procedure.
(processes): Fill "command" field with /proc/pid/comm content and
"command-line" field with /proc/pid/cmdline content. Adapt "process"
construction accordingly.
(daemon-sessions): Identify guix-daemon main processes by filtering process
with "command" field set to "guix-daemon" and guix-daemon children by
filtering process with "command" field set to "guix/...".
In "child-process->session", parse children "command" field to extract client
pids.
(daemon-session->recutils): Adapt accordingly.
* tests/processes.scm (client): Guix-daemon client process command is now
"guix/...". Adapt accordingly.
---
 guix/scripts/processes.scm   | 78 +++++++++++++++++++-----------------
 nix/nix-daemon/nix-daemon.cc | 15 +++++++
 tests/processes.scm          |  2 +-
 3 files changed, 58 insertions(+), 37 deletions(-)

diff --git a/guix/scripts/processes.scm b/guix/scripts/processes.scm
index a2ab017490..6586da5996 100644
--- a/guix/scripts/processes.scm
+++ b/guix/scripts/processes.scm
@@ -32,6 +32,7 @@
             process-id
             process-parent-id
             process-command
+            process-command-line
             processes
 
             daemon-session?
@@ -45,11 +46,12 @@
 
 ;; Process as can be found in /proc on GNU/Linux.
 (define-record-type <process>
-  (process id parent command)
+  (process id parent command command-line)
   process?
-  (id       process-id)                           ;integer
-  (parent   process-parent-id)                    ;integer | #f
-  (command  process-command))                     ;list of strings
+  (id            process-id)               ;integer
+  (parent        process-parent-id)        ;integer | #f
+  (command       process-command)          ;string
+  (command-line  process-command-line))    ;list of strings
 
 (define (write-process process port)
   (format port "#<process ~a>" (process-id process)))
@@ -67,6 +69,9 @@
            (string->number (string-trim-both (string-drop line 5)))
            (loop))))))
 
+(define (read-command port)
+  (string-trim-right (read-string port) #\newline))
+
 (define %not-nul
   (char-set-complement (char-set #\nul)))
 
@@ -89,9 +94,12 @@ processes."
                       (call-with-input-file (string-append "/proc/" pid "/status")
                         read-status-ppid))
                     (define command
+                      (call-with-input-file (string-append "/proc/" pid "/comm")
+                        read-command))
+                    (define command-line
                       (call-with-input-file (string-append "/proc/" pid "/cmdline")
                         read-command-line))
-                    (process (string->number pid) ppid command))
+                    (process (string->number pid) ppid command command-line))
                   (lambda args
                     (if (= ENOENT (system-error-errno args))
                         #f
@@ -131,21 +139,17 @@ active sessions, and the master 'guix-daemon' process."
          (string-suffix? ".lock" file)))
 
   (let* ((processes (processes))
-         (daemons   (filter (lambda (process)
-                              (match (process-command process)
-                                ((argv0 _ ...)
-                                 (string=? (basename argv0) "guix-daemon"))
-                                (_ #f)))
-                            processes))
-         (children  (filter (lambda (process)
-                              (match (process-command process)
-                                ((argv0 (= string->number argv1) _ ...)
-                                 (integer? argv1))
-                                (_ #f)))
-                            daemons))
-         (master    (remove (lambda (process)
-                              (memq process children))
-                            daemons)))
+         (daemons   (filter
+                     (lambda (process)
+                       (string=? (process-command process) "guix-daemon"))
+                     processes))
+         ;; Guix-daemon children have their command set to
+         ;; "guix/<client-pid>".
+         (children  (filter
+                     (lambda (process)
+                       (string-prefix? "guix/" (process-command process)))
+                     processes)))
+
     (define (lookup-process pid)
       (find (lambda (process)
               (and (process-id process)
@@ -159,22 +163,24 @@ active sessions, and the master 'guix-daemon' process."
               processes))
 
     (define (child-process->session process)
-      (match (process-command process)
-        ((argv0 (= string->number client) _ ...)
-         (let ((files  (process-open-files process))
-               (client (lookup-process client)))
-           ;; After a client has died, there's a window during which its
-           ;; corresponding 'guix-daemon' process is still alive, in which
-           ;; case 'lookup-process' returns #f.  In that case ignore the
-           ;; session.
-           (and client
-                (daemon-session process client
-                                (lookup-children
-                                 (process-id process))
-                                (filter lock-file? files)))))))
+      (let* ((command (process-command process))
+             (client (string->number
+                      (substring command
+                                 (1+ (string-index command #\/)))))
+             (files  (process-open-files process))
+             (client (lookup-process client)))
+        ;; After a client has died, there's a window during which its
+        ;; corresponding 'guix-daemon' process is still alive, in which
+        ;; case 'lookup-process' returns #f.  In that case ignore the
+        ;; session.
+        (and client
+             (daemon-session process client
+                             (lookup-children
+                              (process-id process))
+                             (filter lock-file? files)))))
 
     (values (filter-map child-process->session children)
-            master)))
+            daemons)))
 
 (define (daemon-session->recutils session port)
   "Display SESSION information in recutils format on PORT."
@@ -183,14 +189,14 @@ active sessions, and the master 'guix-daemon' process."
   (format port "ClientPID: ~a~%"
           (process-id (daemon-session-client session)))
   (format port "ClientCommand:~{ ~a~}~%"
-          (process-command (daemon-session-client session)))
+          (process-command-line (daemon-session-client session)))
   (for-each (lambda (lock)
               (format port "LockHeld: ~a~%" lock))
             (daemon-session-locks-held session))
   (for-each (lambda (process)
               (format port "ChildProcess: ~a:~{ ~a~}~%"
                       (process-id process)
-                      (process-command process)))
+                      (process-command-line process)))
             (daemon-session-children session)))
 
 
diff --git a/nix/nix-daemon/nix-daemon.cc b/nix/nix-daemon/nix-daemon.cc
index 3dd156ba77..467439bb56 100644
--- a/nix/nix-daemon/nix-daemon.cc
+++ b/nix/nix-daemon/nix-daemon.cc
@@ -16,6 +16,7 @@
 #include <signal.h>
 #include <sys/types.h>
 #include <sys/wait.h>
+#include <sys/prctl.h>
 #include <sys/stat.h>
 #include <sys/socket.h>
 #include <sys/un.h>
@@ -967,9 +968,23 @@ static void acceptConnection(int fdSocket)
                 /* Restore normal handling of SIGCHLD. */
                 setSigChldAction(false);
 
+
                 /* For debugging, stuff the pid into argv[1]. */
                 if (clientPid != -1 && argvSaved[1]) {
                     string processName = std::to_string(clientPid);
+                    string new_pr_name =
+                        "guix/" + processName;
+                    /*
+                     * Stuffing the pid into argv[1] does not work if
+                     * guix-daemon in run with binfmt. Change the process name
+                     * to guix/pid, so that there is another way to find the
+                     * client pid.
+                     */
+                    prctl(PR_SET_NAME,
+                          new_pr_name.c_str(),
+                          NULL,
+                          NULL,
+                          NULL);
                     strncpy(argvSaved[1], processName.c_str(), strlen(argvSaved[1]));
                 }
 
diff --git a/tests/processes.scm b/tests/processes.scm
index 40454bcbc7..ffb9f507f4 100644
--- a/tests/processes.scm
+++ b/tests/processes.scm
@@ -48,7 +48,7 @@
                           (daemon-sessions)))
            (daemon  (daemon-session-process session)))
       (and (kill (process-id daemon) 0)
-           (string-suffix? "guix-daemon" (first (process-command daemon)))))))
+           (string-prefix? "guix/" (process-command daemon))))))
 
 (test-assert "client + lock"
   (with-store store
-- 
2.24.0


--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 27 Nov 2019 10:42:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Nov 27 05:42:18 2019
Received: from localhost ([127.0.0.1]:53475 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iZum2-0004y1-Gk
	for submit <at> debbugs.gnu.org; Wed, 27 Nov 2019 05:42:18 -0500
Received: from lists.gnu.org ([209.51.188.17]:48371)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZum1-0004xq-1c
 for submit <at> debbugs.gnu.org; Wed, 27 Nov 2019 05:42:17 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:36397)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZulz-0001FV-Fl
 for bug-guix@HIDDEN; Wed, 27 Nov 2019 05:42:16 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-0.5 required=5.0 tests=BAYES_05,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZuly-0005Hb-Eh
 for bug-guix@HIDDEN; Wed, 27 Nov 2019 05:42:15 -0500
Received: from mail-wr1-x435.google.com ([2a00:1450:4864:20::435]:39105)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <m.othacehe@HIDDEN>)
 id 1iZuly-0005GE-7M
 for bug-guix@HIDDEN; Wed, 27 Nov 2019 05:42:14 -0500
Received: by mail-wr1-x435.google.com with SMTP id y11so22956746wrt.6
 for <bug-guix@HIDDEN>; Wed, 27 Nov 2019 02:42:13 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=references:user-agent:from:to:subject:in-reply-to:date:message-id
 :mime-version; bh=st9d85u7YaJhVk1GEZ2GqDeBJ35pusAn5sGVA7QA26A=;
 b=ggr6+NS/FUnoDu/iFMevEeztxzx1deXKyPjFK5ACwGrlHmH2Ap0bhGAkOZvbSpl5G0
 iuA6eX/j8ppbxHB6y5ERYNQFcBVJYDHgPZpNMjQ7EBDC9uD4uV23t5sKp5uDZs565QNc
 ZcVX15DGyl2VwaUdc2F0mPdCqC/8oXVIj0nT4APGLA63IAqJQ+oHwx3lkdYrHcT7XiJB
 U3ZIRsbHkoLAT5vIQ29BUFscgCQ75u9GH6myrsDUUJWJxZNNz6x2vOvtzdKDpy5YwT9b
 BMBj0qR8GqnNLbFNNSrDjxvZ0MNuCcoAUZf+mGBuSlxZtObSxh0VS5F2ZBMYSInxqKKG
 0L3A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:references:user-agent:from:to:subject
 :in-reply-to:date:message-id:mime-version;
 bh=st9d85u7YaJhVk1GEZ2GqDeBJ35pusAn5sGVA7QA26A=;
 b=k+EYOk1FibsoR/Kuq7eg2M6uODDb1WSu4K/lXYHYIAFNtYLp0jsM2cNplUMy9i6K+u
 UqRm7bFgCZJ8YxWB7h/5tHsC4+Uk/vSvTPYWyJvK1/QxSMQO0UrNhlHQ55YPKvFQWYr6
 /kiVViWOygZRJOzP26Fx1PrA3I+9DOXPefJ8EahrnZIX+Lyb5RjZR23tuQHxU/u+r2Rq
 Ew2MG5xQe/Sd2LMlp2O8YGToIvQeUfKblxGH2aGH8trxLIfqKdtCodkq+NBbknZLIMTA
 luhPxUzumT72Wn/xtgkoPMSIHW4POGizxIkKrxkJ2jH3XNLF/noUwHDaxmLgXfHkNIo/
 guwA==
X-Gm-Message-State: APjAAAXl8h2c/PT+Z9KSEnchprmI45V39QzNaws9vx8KUfv3Q8L+EDJX
 fxDb9kpcuTWBxG48JWdoW04o/MhO
X-Google-Smtp-Source: APXvYqwGzz7kTh9yfoxyJnSMH2gSF8tWtHMFldztIpPHYeKZ6YsV8jS0HTZ5ZLeNp9/VnM8Yp0/AIw==
X-Received: by 2002:a5d:630d:: with SMTP id i13mr25995895wru.369.1574851332108; 
 Wed, 27 Nov 2019 02:42:12 -0800 (PST)
Received: from meru (lfbn-ann-1-237-90.w86-200.abo.wanadoo.fr. [86.200.196.90])
 by smtp.gmail.com with ESMTPSA id s8sm5981971wmc.39.2019.11.27.02.42.09
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Wed, 27 Nov 2019 02:42:10 -0800 (PST)
References: <87a78ktbqm.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Mathieu Othacehe <m.othacehe@HIDDEN>
To: bug-guix@HIDDEN
Subject: Re: Guix 1.0.1-10.41b4b71 test fails on armhf
In-reply-to: <87a78ktbqm.fsf@HIDDEN>
Date: Wed, 27 Nov 2019 11:42:08 +0100
Message-ID: <87pnhdbny7.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::435
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

--=-=-=
Content-Type: text/plain


About the failing test below, lzip is not found on armhf and all tests
are skipped but the last one, that fails.

The patch attached, makes sure that this test is also skipped if lzip is
not found.

Now I'm not sure why it is not found but that's another matter.

WDYT?

Mathieu

> --8<---------------cut here---------------start------------->8---
> test-name: make-lzip-input-port/compressed
> location: /tmp/guix-build-guix-1.0.1-10.41b4b71.drv-0/source/tests/lzlib.scm:111
> source:
> + (test-assert
> +   "make-lzip-input-port/compressed"
> +   (let* ((len (pk 'len (+ 10 (random 4000 %seed))))
> +          (data (random-bytevector len))
> +          (compressed
> +            (make-lzip-input-port/compressed
> +              (open-bytevector-input-port data)))
> +          (result
> +            (call-with-lzip-input-port
> +              compressed
> +              get-bytevector-all)))
> +     (pk (bytevector-length result)
> +         (bytevector-length data))
> +     random seed for tests: 1574602043
> (bytevector=? result data)))
>
> ;;; (len 3501)
> actual-value: #f
> actual-error:
> + (wrong-type-arg
> +   #f
> +   "Wrong type to apply: ~S"
> +   (#f)
> +   (#f))
> result: FAIL


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-tests-lzlib-Do-not-fail-if-lzlib-in-not-available.patch

From 13d2014879372a947e3239c14bdc9f6ae8f3c318 Mon Sep 17 00:00:00 2001
From: Mathieu Othacehe <m.othacehe@HIDDEN>
Date: Tue, 26 Nov 2019 08:31:43 +0100
Subject: [PATCH] tests: lzlib: Do not fail if lzlib in not available.

* tests/lzlib.scm: Use test-assert* for all test cases, so that there are no
failures if lzlib is unavailable.
---
 tests/lzlib.scm | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/tests/lzlib.scm b/tests/lzlib.scm
index 543622bb45..d8d0e6edf8 100644
--- a/tests/lzlib.scm
+++ b/tests/lzlib.scm
@@ -108,7 +108,7 @@
 (test-assert* "Bytevector of size relative to Lzip internal buffers (1MiB+1)"
   (compress-and-decompress (random-bytevector (1+ (* 1024 1024)))))
 
-(test-assert "make-lzip-input-port/compressed"
+(test-assert* "make-lzip-input-port/compressed"
   (let* ((len        (pk 'len (+ 10 (random 4000 %seed))))
          (data       (random-bytevector len))
          (compressed (make-lzip-input-port/compressed
-- 
2.24.0


--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 26 Nov 2019 10:53:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 26 05:53:24 2019
Received: from localhost ([127.0.0.1]:50641 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iZYTE-00008B-3T
	for submit <at> debbugs.gnu.org; Tue, 26 Nov 2019 05:53:24 -0500
Received: from lists.gnu.org ([209.51.188.17]:42853)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZYTC-000083-Pv
 for submit <at> debbugs.gnu.org; Tue, 26 Nov 2019 05:53:23 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:34661)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZYTB-0001Xk-Rq
 for bug-guix@HIDDEN; Tue, 26 Nov 2019 05:53:22 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.0 required=5.0 tests=BAYES_20,FREEMAIL_FROM
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZYTA-0000o9-TO
 for bug-guix@HIDDEN; Tue, 26 Nov 2019 05:53:21 -0500
Received: from mail-wm1-x32c.google.com ([2a00:1450:4864:20::32c]:35554)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <m.othacehe@HIDDEN>)
 id 1iZYTA-0000nn-Nb
 for bug-guix@HIDDEN; Tue, 26 Nov 2019 05:53:20 -0500
Received: by mail-wm1-x32c.google.com with SMTP id n5so2763522wmc.0
 for <bug-guix@HIDDEN>; Tue, 26 Nov 2019 02:53:20 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=references:user-agent:from:to:subject:in-reply-to:date:message-id
 :mime-version; bh=c3FE+UxJ231WK3NyrCaTpU2P2qEmEejM9inS4R5uDhw=;
 b=aj1jtp5VdI91z/UNxz4sh6huNjm44bF0IYWquSdBxW9jnvVixhbJNWqPOF/ZG/g8tj
 QYqMk2jA+S7lG8j4GzXG6YuSG2JCoGmGsd8ot69bhUQIrlrwkAC3S9Lz0fkh1XjWQ2hJ
 4REoQDOPndL5WnAaLpV2Z3QaAYWnA1XJ/shePHRXlXPavPyviU5xQ7uNUq9/JBLcVzJL
 PDmEhDIFQfMtjtnUZpdMhn3LJD09/YOZVg1fZ11f2JDKLpWQbWteRDpKVEYSYQfmBby+
 8fA9BTwu7Tyc1ZyB1EO9ByF0EbheWMFBq1tBQnFnDPa3VcZKWcAql0EfLZOs0h8J18WQ
 qimA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:references:user-agent:from:to:subject
 :in-reply-to:date:message-id:mime-version;
 bh=c3FE+UxJ231WK3NyrCaTpU2P2qEmEejM9inS4R5uDhw=;
 b=afsMHRB+5VGcjkM6mGB0dWkWbgDCAm0IfjKI7XHteBqhgTAce6AG4cJol51QDG/Fiu
 0pySrk8hb8aff9/mDo8KSyd0ML9IOV4hcr1bOyEDvgni8Y6VjTiaXkVwJgsobKCoG3SY
 +gUMidp8dSz9C6dHr/5FDhw2OsivtKMZEtqLJsV4h3JVLrESH3n9Tyn6UVM4aN3iHo2N
 FcrbOrdYDGrWRMth4X6MIBAFEZ/Dy0L+M+s0Ro9P66lngvkhQ7VOFLHtnnKADwOx0Sxp
 rsV4xFSNQHj+V7x6tgNUjvZ899o8hvsXANmEyi40YW7EkgsVsWGy2igYf+uJ/mHhKuhx
 YiKQ==
X-Gm-Message-State: APjAAAUTJNaH8BdhlGLTcEkIg+WRc6uAWIHFkCJl0iQVfBJdmjwkLLOT
 jngKA5v1d8xlRO/Fb3WnRt75xQJe
X-Google-Smtp-Source: APXvYqwcxwfbS1+LRxaVWLLIpkCKsiZuqFhAab6wKv1kWHEHcm35fZm6wiGbCyct/eFvqBqlucEY1w==
X-Received: by 2002:a05:600c:296:: with SMTP id
 22mr3624456wmk.155.1574765599334; 
 Tue, 26 Nov 2019 02:53:19 -0800 (PST)
Received: from meru (lfbn-ann-1-237-90.w86-200.abo.wanadoo.fr. [86.200.196.90])
 by smtp.gmail.com with ESMTPSA id r6sm336181wrq.92.2019.11.26.02.53.17
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Tue, 26 Nov 2019 02:53:18 -0800 (PST)
References: <87a78ktbqm.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Mathieu Othacehe <m.othacehe@HIDDEN>
To: bug-guix@HIDDEN
Subject: Re: Guix 1.0.1-10.41b4b71 test fails on armhf
In-reply-to: <87a78ktbqm.fsf@HIDDEN>
Date: Tue, 26 Nov 2019 11:53:16 +0100
Message-ID: <87zhgisycj.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::32c
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


Mmmh, I get what's going on in tests/processes.scm. It's an issue in
(guix scripts processes) where argv0 is checked for "guix-daemon".

When using --system my-system, argv0 is "qemu-my-system". So we need to
check both argv0 and argv1 for "guix-daemon".

I'll propose a patch.

Mathieu




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.
Disconnected #38359 from all other report(s). Request was from Jack Hill <jackhill@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 38359 <at> debbugs.gnu.org:


Received: (at 38359) by debbugs.gnu.org; 25 Nov 2019 22:08:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 25 17:08:28 2019
Received: from localhost ([127.0.0.1]:49839 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iZMWy-0007TC-Dv
	for submit <at> debbugs.gnu.org; Mon, 25 Nov 2019 17:08:28 -0500
Received: from minsky.hcoop.net ([104.248.1.95]:60316)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <jackhill@HIDDEN>) id 1iZMWx-0007T0-3Y
 for 38359 <at> debbugs.gnu.org; Mon, 25 Nov 2019 17:08:27 -0500
Received: from marsh.hcoop.net ([45.55.52.66])
 by minsky.hcoop.net with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.89) (envelope-from <jackhill@HIDDEN>)
 id 1iZMWr-0005ky-UE
 for 38359 <at> debbugs.gnu.org; Mon, 25 Nov 2019 17:08:21 -0500
Date: Mon, 25 Nov 2019 17:08:21 -0500 (EST)
From: Jack Hill <jackhill@HIDDEN>
X-X-Sender: jackhill@HIDDEN
To: 38359 <at> debbugs.gnu.org
Subject: Mistaken merge
Message-ID: <alpine.DEB.2.20.1911251707310.11560@HIDDEN>
User-Agent: Alpine 2.20 (DEB 67 2015-01-07)
MIME-Version: 1.0
Content-Type: text/plain; format=flowed; charset=US-ASCII
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38359
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Oops, I didn't mean to merge this bug with the other ones. I'll look up 
how to unmerge shortly.

Apologies,
Jack




Information forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.
Merged 38359 38377 38379 38380. Request was from Jack Hill <jackhill@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Nov 2019 12:51:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Nov 25 07:51:52 2019
Received: from localhost ([127.0.0.1]:47744 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iZDqJ-0005Ji-Jr
	for submit <at> debbugs.gnu.org; Mon, 25 Nov 2019 07:51:52 -0500
Received: from lists.gnu.org ([209.51.188.17]:49370)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZDqH-0005JQ-Ly
 for submit <at> debbugs.gnu.org; Mon, 25 Nov 2019 07:51:50 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:54435)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZCuO-0005b4-DP
 for bug-guix@HIDDEN; Mon, 25 Nov 2019 06:52:02 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <m.othacehe@HIDDEN>) id 1iZCuM-0000HI-J1
 for bug-guix@HIDDEN; Mon, 25 Nov 2019 06:52:00 -0500
Received: from mail-wm1-x332.google.com ([2a00:1450:4864:20::332]:40166)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <m.othacehe@HIDDEN>)
 id 1iZCuI-000056-OQ
 for bug-guix@HIDDEN; Mon, 25 Nov 2019 06:51:55 -0500
Received: by mail-wm1-x332.google.com with SMTP id y5so15596450wmi.5
 for <bug-guix@HIDDEN>; Mon, 25 Nov 2019 03:51:53 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=user-agent:from:to:subject:date:message-id:mime-version;
 bh=6RcQnjT0JgYY/Qw2u5HvFhFQUNaEonH3ALp96HveKmo=;
 b=BGN/KRFGu5IEXbUI7cKF2Ylw+E5rkBG4ZNaLewtV3Fb7qiUDd+5a5LBHV9NLnrT7W5
 taCLsASgyibLLsnhpLZu4BPPupcUC/FDvT4N7o8Pgbqw6aY3tFsLnQwy4YdREf3Z2L8/
 2I0pMsx4cdcKPiKye7y+SllybrIRUIgWPlYQ37R1R+T+vnKGPhDzBV0ZuD31PRrZMtt/
 7F/aTZbOBccuKDfS0XVgJEC0wHr9OuM0q7iDHhPT7CKTDcEdGF15rTpjUNTMxWpS9qeA
 biMPkSKxUYj/cGJcyI5tWoeO8XCrsiVxzmUD9+3QGUwMI9nwo4KywmnRqaiXU8dZbj57
 uNUA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:user-agent:from:to:subject:date:message-id
 :mime-version;
 bh=6RcQnjT0JgYY/Qw2u5HvFhFQUNaEonH3ALp96HveKmo=;
 b=Pz+Pmo3yj04E3W1YxtDhNzsgHv/jlOSxzhSpzfY2cSKskfQW+9sYzM89nuO6Ft6TGB
 QHoxwn7zmd5S33mZQB2euFX5ky07qoOGr/MvMs+nY1dRgCYjmatwFBCpvj9bVYPU7JTH
 WU5L+rsXIOiCGV2jCWOazK4inZwLlJ+4uTwAK891tYZj7ZsOMlXAGtHs+BcZ5drGF3YZ
 J5/dXsTK3FR7NtVgMMe2r1nn41n+hMZiB8ZxP6HhNd16G+FO8ZNpa0Rzr/6F33awOjVb
 E1+GHvdVlLK4xMdb3GL1UJH66kpIa26Kt5TU74HM55nSluF7gch0UCcvyXweQ8uju3+1
 ez3w==
X-Gm-Message-State: APjAAAVrno4yvfENHXc9rKNXOX/43IaPrWl4ecG/9d2wB3rfwOHhiUaH
 fjxl/Y1L6U0o0ZyezYEZa/he2E7J
X-Google-Smtp-Source: APXvYqypr6+PAhqnbj4RDVTzJxEKx9+NJYXWmTC48uxd3HQAYE13kV+RBmyTHlYSQFBucbwoxplpRA==
X-Received: by 2002:a7b:cc90:: with SMTP id p16mr23657038wma.166.1574682710302; 
 Mon, 25 Nov 2019 03:51:50 -0800 (PST)
Received: from meru (lfbn-ann-1-237-90.w86-200.abo.wanadoo.fr. [86.200.196.90])
 by smtp.gmail.com with ESMTPSA id x10sm10230965wrp.58.2019.11.25.03.51.48
 for <bug-guix@HIDDEN>
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 25 Nov 2019 03:51:49 -0800 (PST)
User-agent: mu4e 1.2.0; emacs 26.3
From: Mathieu Othacehe <m.othacehe@HIDDEN>
To: bug-guix@HIDDEN
Subject: Guix 1.0.1-10.41b4b71 test fails on armhf
Date: Mon, 25 Nov 2019 12:51:45 +0100
Message-ID: <87a78ktbqm.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2a00:1450:4864:20::332
X-Spam-Score: 0.7 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)


Hello,

I have 3 failing tests when building guix 1.0.1-10.41b4b71 on armhf. I
didn't build with -K argument and as it takes ~10 hours, so I'll just paste
my terminal output for now.

It seems to fail on ci.guix.info but the log is partial?

http://ci.guix.info/log/ma98kc90y5jp7h1ydxjlfa7r3nx0sd37-guix-1.0.1-10.41b4b71

Here is my output:

--8<---------------cut here---------------start------------->8---
=================================================
   GNU Guix 1.0.1-10.41b4b71: ./test-suite.log
=================================================
  
# TOTAL: 975
# PASS:  903
# SKIP:  67
# XFAIL: 2
# FAIL:  3
# XPASS: 0
# ERROR: 0
--8<---------------cut here---------------end--------------->8---

and the failing tests:

--8<---------------cut here---------------start------------->8---
test-name: make-lzip-input-port/compressed
location: /tmp/guix-build-guix-1.0.1-10.41b4b71.drv-0/source/tests/lzlib.scm:111
source:
+ (test-assert
+   "make-lzip-input-port/compressed"
+   (let* ((len (pk 'len (+ 10 (random 4000 %seed))))
+          (data (random-bytevector len))
+          (compressed
+            (make-lzip-input-port/compressed
+              (open-bytevector-input-port data)))
+          (result
+            (call-with-lzip-input-port
+              compressed
+              get-bytevector-all)))
+     (pk (bytevector-length result)
+         (bytevector-length data))
+     random seed for tests: 1574602043
(bytevector=? result data)))

;;; (len 3501)
actual-value: #f
actual-error:
+ (wrong-type-arg
+   #f
+   "Wrong type to apply: ~S"
+   (#f)
+   (#f))
result: FAIL
--8<---------------cut here---------------end--------------->8---

and,

--8<---------------cut here---------------start------------->8---
test-name: client
location: /tmp/guix-build-guix-1.0.1-10.41b4b71.drv-0/source/tests/processes.scm:43
source:
+ (test-assert
+   "client"
+   (with-store
+     store
+     (let* ((session
+              (find (lambda (session)
+                      (= (getpid)
+                         (process-id (daemon-session-client session))))
+                    (daemon-sessions)))
+            (daemon (daemon-session-process session)))
+       (and (kill (process-id daemon) 0)
+            (string-suffix?
+              "guix-daemon"
+              (first (process-command daemon)))))))
actual-value: #f
actual-error:
+ (wrong-type-arg
+   "struct_vtable"
+   "Wrong type argument in position ~A (expecting ~A): ~S"
+   (1 "struct" #f)
+   (#f))
result: FAIL
--8<---------------cut here---------------end--------------->8---

and,

--8<---------------cut here---------------start------------->8---
test-name: client + lock
location: /tmp/guix-build-guix-1.0.1-10.41b4b71.drv-0/source/tests/processes.scm:53
source:
+ (test-assert
+   "client + lock"
+   (with-store
+     store
+     (call-with-temporary-directory
+       (lambda (directory)
+         (let* ((token1 (string-append directory "/token1"))
+                (token2 (string-append directory "/token2"))
+                (exp (gexp (begin
+                             (ungexp (random-text))
+                             (mkdir (ungexp token1))
+                             (let loop ()
+                               (unless
+                                 (file-exists? (ungexp token2))
+                                 (sleep 1)
+                                 (loop)))
+                             (mkdir (ungexp output)))))
+                (guile (package-derivation store %bootstrap-guile))
+                (drv (run-with-store
+                       store
+                       (gexp->derivation
+                         "foo"
+                         exp
+                         #:guile-for-build
+                         guile)))
+                (thread
+                  (call-with-new-thread
+                    (lambda () (build-derivations store (list drv)))))
+                (_ (let loop ()
+                     (unless
+                       (file-exists? token1)
+                       (usleep 200)
+                       (loop))))
+                (session
+                  (find (lambda (session)
+                          (= (getpid)
+                             (process-id (daemon-session-client session))))
+                        (daemon-sessions)))
+                (locks (daemon-session-locks-held (pk 'session session))))
+           (call-with-output-file token2 (const #t))
+           (equal?
+             (list (string-append
+                     (derivation->output-path drv)
+                     ".lock"))
+             locks))))))

;;; (session #f)
actual-value: #f
actual-error:
+ (wrong-type-arg
+   "struct_vtable"
+   "Wrong type argument in position ~A (expecting ~A): ~S"
+   (1 "struct" #f)
+   (#f))
result: FAIL
--8<---------------cut here---------------end--------------->8---

Thanks,

Mathieu




Acknowledgement sent to Mathieu Othacehe <m.othacehe@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#38359; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 10 Dec 2019 13:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.